#include <Modules.h>
#include <TextMode_X86.h>
#include <Multiboot.h>

unsigned CModules::ModulesBegAddress[250];
unsigned CModules::ModulesEndAddress[250];
char *CModules::ModulesName[250];
unsigned CModules::PlacementAddress;

void CModules::SetupModuleTable()
{
	module_t *mod;
    int i;
     
	CTextMode_X86::printf ("mods_count = %d, mods_addr = 0x%x\n",
		(int) CMultiboot::MultibootHeader->mods_count, (int) CMultiboot::MultibootHeader->mods_addr);
	for (i = 0, mod = (module_t *) CMultiboot::MultibootHeader->mods_addr;
		i < CMultiboot::MultibootHeader->mods_count;
		i++, mod++)
	{
		CTextMode_X86::printf (" %d:mod_start = 0x%x, mod_end = 0x%x, string = %s\n",
			i,
			mod->mod_start,
			mod->mod_end,
			mod->string);
		if( i <= 250)
		{
			ModulesBegAddress[i] = mod->mod_start;
			ModulesEndAddress[i] = mod->mod_end;
			ModulesName[i] = mod->string;
		}
	}

	CModules::PlacementAddress = GetModule(CMultiboot::MultibootHeader->mods_count - 1)->mod_end;

	CTextMode_X86::printf("Memory Placement Address: 0x%x\n", PlacementAddress);
}

void CModules::ShowModuleTable()
{
}

CModules::module_t *CModules::GetModule(int n)
{
	module_t *mod;
	mod->mod_end = ModulesEndAddress[n];
	mod->mod_start = ModulesBegAddress[n];
	mod->string = ModulesName[n];
	return mod;
}