#include <TextMode_X86.h>	
#include <isr.h>
#include <externs.h>
#include <Common.h>

isr_t interrupt_handlers[256];

extern "C" void isr_handler(registers_t regs)
{
	CTextMode_X86::printf("recieved interrupt: %d\n", regs.int_no);

	if (interrupt_handlers[regs.int_no] != 0)
    {
        isr_t handler = interrupt_handlers[regs.int_no];
        handler(regs);
    }
}

extern "C" void irq_handler(registers_t regs)
{
   // Send an EOI (end of interrupt) signal to the PICs.
   // If this interrupt involved the slave.
   if (regs.int_no >= 40)
   {
       // Send reset signal to slave.
	   CCommon::outb(0xA0, 0x20);
   }
   // Send reset signal to master. (As well as slave, if necessary).
   CCommon::outb(0x20, 0x20);

   if (interrupt_handlers[regs.int_no] != 0)
   {
       isr_t handler = interrupt_handlers[regs.int_no];
       handler(regs);
   }
}

void register_interrupt_handler(unsigned char n, isr_t handler)
{
  interrupt_handlers[n] = handler;
}