#include <TextMode_X86.h>
#include <version.h>
#include <DescriptorTables.h>
#include <PIT.h>
#include <CPUID.h>
#include <Multiboot.h>
#include <Modules.h>
#include <Common.h>

extern "C" void kmain(CMultiboot::multiboot_info_t* mbd, unsigned int magic)
{
	CMultiboot::MultibootHeader = mbd;

	CTextMode_X86::cls(); // cls here to intialise CTextMode_X86::video as well as clear screen if not already
	CTextMode_X86::printf("NasuTek Ensemble Version %s.%s (Build %s)", MAJOR_VERSION, MINOR_VERSION, BUILD_VERSION);
	#ifdef SERVICEPACK_VERSION
	CTextMode_X86::printf(" Service Pack %s", SERVICEPACK_VERSION);
	#endif
	CTextMode_X86::printf("\nCopyright (C) 2008-%s NasuTek Systems\n", YEAR_VERSION);
	CTextMode_X86::printf("Compiled with GCC Version %s\n",__VERSION__);
	CTextMode_X86::printf("Compiled on %s %s\n\n", __DATE__, __TIME__);

	CDescriptorTables::init_descriptor_tables();
	CCPUID::detect_cpu();

	CModules::SetupModuleTable();

	CModules::module_t *mod = CModules::GetModule(0);

	CPIT::init_timer(50);

	asm ("int $32") // Where i manually called INT 32 to call the IRQ to see if its actually being registered
}